<?php
/**
 * @package framework.service
 */
class PHPTALService extends BaseService
{
	/**
	 * the singleton instance
	 * @var PHPTALService
	 */
	private static $instance = null;

	/**
	 * @return PHPTALService
	 */
	public static function getInstance()
	{
		if (self::$instance === null)
		{
			self::$instance = self::getServiceClassInstance(get_class());
		}
		return self::$instance;
	}
	
	private function getBuildFilePath()
	{
		return f_util_FileUtils::buildChangeBuildPath('PHPTAL_change.php');
	}

	/**
	 * @param PHPTAL_Namespace_CHANGE $namespaceCHANGE
	 */
	public function registerAttributes($namespaceCHANGE)
	{
		$file = $this->getBuildFilePath();
		if (!file_exists($file))
		{
			$this->compileAttributes();			
		}
		include_once $file;		
	}
	
	public function compileAttributes()
	{
		Framework::info(__METHOD__);
		$content = array('<?php');
		$content[] = '// Auto generated by ' . __METHOD__ . ' on ' . date_Calendar::getInstance()->toString();
		$content[] = '	framework_PHPTAL_CHANGE::addAttributes($namespaceCHANGE);';
		foreach (ModuleService::getInstance()->getModules() as $package) 
		{
			$classe = str_replace('modules_', '', $package) . '_PHPTAL_CHANGE';
			if (f_util_ClassUtils::classExists($classe))
			{
				$content[] = '	' . $classe . '::addAttributes($namespaceCHANGE);';
			}
		}
		f_util_FileUtils::write($this->getBuildFilePath(), implode("\n", $content), f_util_FileUtils::OVERRIDE);
	}
}
